package io.tswf.transmutations.transmute.annotation;

import io.tswf.transmutations.common.annotation.ClassReference;
import io.tswf.transmutations.common.annotation.Constant;
import io.tswf.transmutations.common.annotation.FieldDescription;
import io.tswf.transmutations.common.annotation.MethodDescription;
import io.tswf.transmutations.transmute.injection.contexts.InjectionOffset;
import io.tswf.transmutations.transmute.injection.points.LocalVariableCallType;
import io.tswf.transmutations.transmute.injection.points.MethodCallInsnType;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

@Retention(RetentionPolicy.RUNTIME)
public @interface At {
    AtConstant atConstant() default @AtConstant(@Constant(intValue = -1));
    AtExit atExit() default @AtExit;
    AtFieldCall atField() default @AtFieldCall(field = @FieldDescription(name = "<no>", desc = "V"), owner = @ClassReference);
    AtHead atHead() default @AtHead;
    AtLineNumber atLine() default @AtLineNumber(lineNumbers = 1);
    AtLocalVariableCall atLocalVariable() default @AtLocalVariableCall(callType = LocalVariableCallType.GET, index = 1, variableType = @ClassReference);
    AtMethodCall atMethod() default @AtMethodCall(method = @MethodDescription(name = "no", descriptor = "no"), owner = @ClassReference(), callType = MethodCallInsnType.INTERFACE);
    AtReturn atReturn() default @AtReturn();
    AtThrow atThrow() default @AtThrow();
    Offset offset() default @Offset(InjectionOffset.NO);
    int skip() default 0;
}
