package io.tswf.transmutations.transmute.injection.missing

import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.meta.MissingTargetStrategy
import io.tswf.transmutations.transmute.meta.TransmutationMethodMetadata
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

interface IMissingTargetStrategyLogic {
    void handleMissingTarget(MissingTargetHandleContext context)
    MissingTargetStrategy getEnumValue()
}

@CheckedMapConstructor
@CompileStatic
class MissingTargetHandleContext {
    TransmutationMethodMetadata transmutationMethodMeta
    ClassNode targetClass
    MethodNode newTargetMethod = null
}