package io.tswf.transmutations.transmute.injection.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.annotation.AtLineNumber
import org.objectweb.asm.tree.AbstractInsnNode
import org.objectweb.asm.tree.LineNumberNode

@AutoService(ITransmutationInjectionPoint)
@CompileStatic
class LineNumberTransmutationInjectionPoint implements ITransmutationInjectionPoint {

    int[] lineNumbers

    LineNumberTransmutationInjectionPoint(int[] lineNumbers) {
        this.lineNumbers = lineNumbers
    }

    @Override
    AbstractInsnNode findNextNodeNearInject(
            InjectionPointSearchContext context
    ) {
        def insnCandidate = context.insnFromSearch

        while (insnCandidate != null) {
            if (insnCandidate instanceof LineNumberNode) {
                if (insnCandidate.line in lineNumbers)
                    return insnCandidate
            }

            insnCandidate = insnCandidate.next
        }

        return null
    }
}