package io.tswf.transmutations.transmute.injection.reader

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.annotation.JumpingToCreatedLabelIfNotNull
import io.tswf.transmutations.transmute.annotation.ReturningValueIfNotNull
import io.tswf.transmutations.transmute.injection.returnvalue.JumpToCreatedLabelReturnValueProcessor
import io.tswf.transmutations.transmute.injection.returnvalue.ReturnObjectIfNotNullReturnValueProcessor

@AutoService(IReturnValueProcessorReader)
@CompileStatic
class JumpToCreatedLabelIfNotNullProcessorReader implements IReturnValueProcessorReader {

    @Override
    void handleReturnValueProcessorReading(ReturnValueProcessorReadingContext readingContext) {
        if (readingContext.transmutationMetadata.transmutationMethod.hasAnnotation(JumpingToCreatedLabelIfNotNull)) {
            readingContext.readedProcessors << new JumpToCreatedLabelReturnValueProcessor()
        }
    }
}
