package io.tswf.transmutations.transmute.injection.reader

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.annotation.ReturnedValue
import io.tswf.transmutations.transmute.annotation.Self
import io.tswf.transmutations.transmute.injection.parameter.ReturnedValueCustomParameterLoader
import io.tswf.transmutations.transmute.injection.parameter.SelfCustomParameterLoader

@AutoService(ICustomParameterLoaderReader)
@CompileStatic
class ReturnedValueCustomParameterLoaderReader implements ICustomParameterLoaderReader {

    @Override
    void handleLoaderSearch(CustomParameterLoaderReadingContext readingContext) {
        if (readingContext.transmutationMetadata.transmutationMethod.hasParameterAnnotation(readingContext.parameterIndex, ReturnedValue)) {
            readingContext.transmutationMetadata.customParameterLoaders << new ReturnedValueCustomParameterLoader()
            readingContext.completed = true
        }
    }
}
