package io.tswf.transmutations.transmute.injection.reader.points

import com.google.auto.service.AutoService
import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.annotation.AtThrow
import io.tswf.transmutations.transmute.injection.points.ThrowTransmutationInjectionPoint
import io.tswf.transmutations.transmute.injection.reader.IInjectionPointReader
import io.tswf.transmutations.transmute.injection.reader.InjectionPointReadingContext

@AutoService(IInjectionPointReader)
@CompileStatic
class ThrowTransmutationInjectionPointReader implements IInjectionPointReader {

    @Override
    void handleInjectionPointReading(InjectionPointReadingContext context) {
        context.result = new ThrowTransmutationInjectionPoint()
    }

    @Override
    Class getMarkerAnnotationClass() {
        return AtThrow
    }
}
