package io.tswf.transmutations.transmute.util

import groovy.transform.CompileStatic
import io.tswf.transmutations.transmute.meta.TransmutationMethodInjectionPointMetadata
import org.objectweb.asm.tree.AnnotationNode

@CompileStatic
class CompositeAtUtil {

    static List<TransmutationMethodInjectionPointMetadata> findInjectionPointsComposite(AnnotationNode transmutationAnnotation) {
        def result = new ArrayList<TransmutationMethodInjectionPointMetadata>()
        // Читаем точки инъекции из параметра 'at' аннотации трансмутации
        transmutationAnnotation.findValueByName("at", AnnotationNode[])
                ?.let { foundAtNodesInTransmutationAnnotation ->
                    foundAtNodesInTransmutationAnnotation.each { injectionPointAt ->
                        def injectionPointMetadata = AtUtil.getInjectionPointMetadataFromAnnotation(injectionPointAt)
                        result << injectionPointMetadata
                    }
                }

        // Читаем точки инъекции из параметра 'dependedAt' аннотации трансмутации
        transmutationAnnotation.findValueByName("dependedAt", AnnotationNode[])
                ?.let { foundAtNodesInTransmutationAnnotation ->
                    foundAtNodesInTransmutationAnnotation.each { injectionPointAt ->
                        def injectionPointMetadata = DependAtUtil.getDependInjectionPointMetadataFromAnnotation(injectionPointAt)
                        result << injectionPointMetadata
                    }
                }

        return result
    }
}
