package io.tswf.transmutations.transmute.util

import groovy.transform.CompileStatic
import org.objectweb.asm.Type
import org.objectweb.asm.commons.Remapper

@CompileStatic
class TransmutationTransferOwnerClassNameRemapper extends Remapper {
    Type transmutationOriginalOwnerClass
    Type transmutationTargetClass

    TransmutationTransferOwnerClassNameRemapper(Type transmutationOriginalOwnerClass, Type transmutationTargetClass) {
        this.transmutationOriginalOwnerClass = transmutationOriginalOwnerClass
        this.transmutationTargetClass = transmutationTargetClass
    }

    @Override
    String map(String internalName) {
        if (internalName == transmutationOriginalOwnerClass.internalName) {
            return transmutationTargetClass.internalName
        }

        return super.map(internalName)
    }
}
